Rotting Oranges - Leetcode 994 - Python

Поделиться
HTML-код
  • Опубликовано: 13 янв 2025

Комментарии • 109

  • @NeetCode
    @NeetCode  3 года назад +4

    More Graph Problems: ruclips.net/video/utDu3Q7Flrw/видео.html

  • @RichardLopez-lr4el
    @RichardLopez-lr4el 3 года назад +154

    If I pass any coding interview, it is because of this channel!!! Keep up the amazing work! 👏🏽

    • @varunshrivastava2706
      @varunshrivastava2706 2 года назад +3

      Have you passed any? (Please say yes 🤞)

    • @RichardLopez-lr4el
      @RichardLopez-lr4el 2 года назад +37

      @@varunshrivastava2706 haha yes 🎉! I just heard back yesterday, and it looks like I’m going to be coworkers with Neetcode!! I’m in a different office, but I can’t say enough good things about how much this channel has helped!

    • @bucketsort3248
      @bucketsort3248 2 года назад +2

      ​@@RichardLopez-lr4el Wow congrats on being Noogler! How long do you study to prepare for your interview?

    • @terellkantwell6876
      @terellkantwell6876 2 года назад

      @@RichardLopez-lr4el hey man i am currently in the process of finding a job, any tips of how you studied to get good at general problems? I struggle a lot starting problems but im starting to see a pattern where some problems are very similar to others in the sense that the solution is the same and differs but a couple lines of code.

  • @nithinsastrytellapuri291
    @nithinsastrytellapuri291 Год назад +21

    I could figure out that this is a BFS problem and started coding it. But the multi BFS approach was out of my reach. Thanks for another great video

  • @americanonobrasil2128
    @americanonobrasil2128 2 года назад +13

    Great as always. Thanks, man. It's funny, when I first started watching I'd ususally skip to the end for the answer and not understand very well if I encountered the problem again or a similar one. The more I watch, the more I realize how important it is to comprehend all the concepts you're talking about and now I watch patiently and try to absorb everything. No excuses for why I wasn't doing that earlier. Thanks again!

  • @TheSahilpadyal
    @TheSahilpadyal 2 года назад +16

    NeetCode is a lifesaver. The way you explain the problem and the code is just amazing. Keep up the good work

  • @alitaha1200
    @alitaha1200 13 дней назад

    i've watched you so much that i came up with your exact solution without looking, love you bro

  • @rajaroy43
    @rajaroy43 2 года назад +9

    This question was asked in an Amazon interview (SDE2)

  • @georgebian5383
    @georgebian5383 Год назад +2

    Thanks!

    • @NeetCode
      @NeetCode  Год назад

      Thank you so much 🙏

  • @ax5344
    @ax5344 2 года назад +4

    Thanks so much for explaining why we cannot use while loop but have to use a list at 9:27!
    I saw their code but I just did not get it! You really know where we got stuck!

  • @quirkyquester
    @quirkyquester Месяц назад

    hard to not think about dfs first, but bfs totally makes sense. thank you so much! you're the G neetcode!

  • @matthewzhang7330
    @matthewzhang7330 3 года назад +8

    I literally finished this question two days before you post this! lol. Glad that my solution is very similar to yours.

    • @BharathKalyanBhamidipati
      @BharathKalyanBhamidipati 3 года назад +2

      Hey! I've covered almost all the data structures upto trees but graphs. Finding graphs a little difficult to even get started with. Could you please share any good resources where I can learn graphs from?

    • @vour6654
      @vour6654 2 года назад +2

      @@BharathKalyanBhamidipati Structy

  • @ritikajaiswal3824
    @ritikajaiswal3824 2 года назад +6

    There are many channels for leetcode solutions for python, but the way you explain is just mind blowing... Ever since I have started only your channel is helping me.. However, When I can't find solutions on your channel for various questions I don't even understand it at the end because nobody is explanation is sufficient. Hence, I'm requesting you to do more leetcode questions I know youre a noogler now, you have been busy but PLEASE I'm requesting you to continue making leetcode solutions.

    • @varunshrivastava2706
      @varunshrivastava2706 2 года назад +2

      Agree with you Ritika the major problem with people who study DSA with Python is lack of good resources. Although you can join the discord server of Official Python community and post your doubts there. I do the same and its really helpful.

  • @ammarqureshi2155
    @ammarqureshi2155 3 года назад +5

    great explanation, this problem would have similarities with the Walls and Gates leetcode problem that you have done previously. keep up the good work :) we appreciate it

  • @prashanthkurella4500
    @prashanthkurella4500 Год назад +2

    You can do this with DFS as well. DFS will visit every orange that BFS does but in the wrong order if you can keep track of what the time was when you visit a certain orange you can just increment that time when you visit the node. All this boils down to is basically finding out the maximum "depth" of the graphs. If there are multiple partitions, you return the maximum time it takes a partition to rot.

    • @gustavo-yv1gk
      @gustavo-yv1gk Год назад

      hey do u have that code for dfs?

    • @MdRahman-lf9iv
      @MdRahman-lf9iv 5 месяцев назад

      @@gustavo-yv1gk
      here you go (this already beats 100% so i didn't optimize it, but technically you could optimize it using another n*m matrix):
      class Solution {
      final int INF = Integer.MAX_VALUE;
      public int orangesRotting(int[][] grid) {
      //well need to find the minimum time in each cell
      //rather than searching from the rotten fruits
      //we can dfs from our fresh fruits and find the closest rotten fruit
      //if there is a freshfuit that has 0 connections to rotten fruits
      //we return -1;
      //the fruit that is the furthest from a rotten fruit
      int max = 0;
      boolean[][] visited = new boolean[grid.length][grid[0].length];
      for(int r = 0; r < grid.length; r++){
      for(int c = 0; c < grid[0].length; c++){
      //we found a fruit we need to find it's nearest
      if(grid[r][c] == 1){
      int val = dfs(visited, grid, r, c, 0);
      if(val == INF){
      return -1;
      }
      //if this is the furthest cell from a rotten fruit then update it
      max = Math.max(max, val);
      }
      }
      }
      return max;
      }
      //distance = distance from nearest rotten fruit. Each distance = 1 min
      private int dfs(boolean[][] visited, int[][] grid, int r, int c, int distance){
      //we have reached the edge but didn't find a rotten fruit
      if(r < 0 || r >= grid.length || c < 0 || c >= grid[0].length){
      return INF;
      }
      if(visited[r][c] || grid[r][c] == 0){
      return INF;
      }
      if(grid[r][c] == 2){
      return distance;
      }
      visited[r][c] = true;
      int leftRight = Math.min(dfs(visited, grid, r+1, c, distance + 1), dfs(visited, grid, r-1, c,distance + 1));
      int downUp = Math.min(dfs(visited, grid, r, c+1, distance + 1), dfs(visited, grid, r, c-1,distance + 1));
      visited[r][c] = false;
      return Math.min(leftRight, downUp);
      }
      }

  • @grovestreet9165
    @grovestreet9165 2 года назад +2

    the explanation is soo good that you don't even need to watch half of the video the way you think and explain is soo good

  • @yadavankit
    @yadavankit Год назад +2

    Over the course of 8-9 years, this question is asked to me thrice in different forms and somehow I wasn't completely able to solve it. I even tried searching a solution online but no luck probably due to different terminologies (zombies / virus / even rotten eggs). Today RUclips decided on it's own that its time for me to learn it 😛

  • @shouryannikam3949
    @shouryannikam3949 3 года назад +4

    Thank you for your service. I've recommended your channel to every CS major that I know.

    • @NeetCode
      @NeetCode  3 года назад +2

      Thanks, much appreciated!

  • @huseyinbarin1653
    @huseyinbarin1653 2 года назад +1

    very clean solution liked it. Thanks

  • @mr6462
    @mr6462 2 года назад +5

    Thanks for this succinct explanation! I have a question, for line 15, is it really necessary to use "fresh > 0" as one of the loop conditions?

    • @bchen1403
      @bchen1403 2 года назад

      I am thinking of the same thing and I see no reason why it would yield error if I take out fresh > 0 condition but it actually did on example 1 provided on Leetcode. Have you figured it out?

    • @hamoodhabibi7026
      @hamoodhabibi7026 2 года назад +8

      It's needed because after we make our last fresh orange => rotten we append that last rotten orange to our queue and decrement fresh count by 1 (So we have 1 rotten in queue and 0 fresh). Now this theoretically shouldn't be a problem because in our code the line right after it "for i in range(len(q)" wouldn't run HOWEVER it is a problem because after it doesn't run the time variable will still be incremented resulting in us returning 1 minute extra where we do nothing in that extra minute

  • @gabchen3000
    @gabchen3000 Год назад +2

    I found it less confusing if I popleft one at a time instead of 3 at a time in this example by passing in a time variable into the queue with the r,c and make sure to increment time when a good orange turns rotten. The directions array + loop makes it hard for me to follow along while I run through an example. Here is my approach, hope this helps people with my kind of monkey brain:
    ROWS = len(grid)
    COLS = len(grid[0])
    maxTime, goodOrange = 0, 0
    q = collections.deque()
    for r in range(ROWS):
    for c in range(COLS):
    if grid[r][c] == 2:
    q.append((r,c,0))
    if grid[r][c] == 1:
    goodOrange += 1
    while q:
    r, c, time = q.popleft()
    maxTime = max(maxTime, time)
    if r+1 < ROWS and grid[r+1][c] == 1:
    goodOrange -= 1
    grid[r+1][c] = 2
    q.append((r+1,c,time+1))
    if r-1 >= 0 and grid[r-1][c] == 1:
    goodOrange -= 1
    grid[r-1][c] = 2
    q.append((r-1,c,time+1))
    if c-1 >= 0 and grid[r][c-1] == 1:
    goodOrange -= 1
    grid[r][c-1] = 2
    q.append((r,c-1,time+1))
    if c+1 < COLS and grid[r][c+1] == 1:
    goodOrange -= 1
    grid[r][c+1] = 2
    q.append((r,c+1,time+1))
    if goodOrange > 0:
    return -1
    return maxTime
    As always great video, thank you for the explanation!

  • @nve-nick
    @nve-nick 3 года назад

    Thank you for some explanations here that I was looking for when looking at results on leetcode such as the for loop used to take snapshot, and it run in one unit time

  • @sanskarkumar028
    @sanskarkumar028 Год назад

    Amazing explanation sir. Greetings from India

  • @SidddB
    @SidddB 3 года назад +4

    Thanks for another great video! I was wondering if you could maybe give an expanded explanation for the "snapshot" for loop inside the while loop? Having a bit of trouble understanding its purpose since we have the main while loop already iterating.

    • @mirrorinfinite5392
      @mirrorinfinite5392 2 года назад +6

      We need to use the for loop with len(q) because len(q) is only evaluated once at the start of the current time loop. So for each rotten orange at that certain time, we pop it and add the new rotten oranges to the queue. If we use something like while(q) instead of the for loop with len(q), it will keep going because we append new rotten oranges to the queue, making it hard for us to keep track of the time.

    • @KNRG04
      @KNRG04 5 месяцев назад

      @@mirrorinfinite5392 2 years later and you've saved me, thank you

  • @asdfgmnbvczxcv
    @asdfgmnbvczxcv 2 года назад +2

    Alternatively you can use dfs but only update a cell if it took less time to get there from a previous source

  • @mingjuhe1514
    @mingjuhe1514 Год назад

    Thanks man. Very great Video!

  • @markolainovic
    @markolainovic 2 года назад +1

    I did it a bit differently, and it has a bit worse time complexity, but it was more intuitive for me this way. Basicaly, I'd go and mark all the oranges that are about to rot and I'd count that as a single increment in final counter. Then I'd go ahead and rot them. Repeat the process as long as the marking step returns True, i.e. at least one orange was found that is about to rot.
    Code:
    class Solution:
    def orangesRotting(self, grid: List[List[int]]) -> int:
    m = len(grid)
    n = len(grid[0])
    def directions(row, col):
    return [
    (row - 1, col),
    (row, col + 1),
    (row + 1, col),
    (row, col - 1),
    ]
    def valid(row, col):
    return row in range(m) and col in range(n)
    def has_fresh_oranges():
    for row in range(m):
    for col in range(n):
    if grid[row][col] == 1:
    return True
    return False
    def mark_oranges_about_to_rot():
    rotten = False
    for row in range(m):
    for col in range(n):
    if grid[row][col] == 1:
    for r, c in directions(row, col):
    if valid(r, c) and grid[r][c] == 2:
    grid[row][col] = 3
    rotten = True
    return rotten
    def rot_oranges():
    for row in range(m):
    for col in range(n):
    if grid[row][col] == 3:
    grid[row][col] = 2
    res = 0
    while mark_oranges_about_to_rot():
    res += 1
    rot_oranges()
    return res if not has_fresh_oranges() else -1

  • @fatiharslan7849
    @fatiharslan7849 Год назад

    dfs works for this algorithm. You can use a minute variable to check if the value is not empty or rotten and if it's bigger than current minute we can make it smaller.
    class Solution {
    public int orangesRotting(int[][] grid) {
    for(int i=0;i

  • @titniumultd
    @titniumultd Год назад +4

    I think Leetcode may have added a new testcase that causes your solution to fail...
    grid =
    [[1],[2],[1],[2]].
    In this case a q.popleft() is necessary, as otherwise our time increments an additional step

    • @nikhil_a01
      @nikhil_a01 Год назад

      Solution still looks fine to me. The code on NeetCode's github passes. I'm doing it the same way as NeetCode and it passes.
      The fresh > 0 check prevents time from incrementing an additional step.

    • @MetinOrak
      @MetinOrak 11 месяцев назад

      I kinda had a similar issue, but solution is correct. I didn't assign the length of queue to a new variable and it was increasing while adding new items to queue. After assigning it to a new variable and using in the loop condition, it worked well.

  • @dusvn1484
    @dusvn1484 2 месяца назад

    Nice explanation neet.I can't figure out by my own becouse I start at r,c(0,0) and this apporch help me a lot ty.

  • @shubhammishra1225
    @shubhammishra1225 2 года назад

    Wow nice solution.. We can use tuples instead array to save more space.

  • @nihao852
    @nihao852 Год назад

    You are my hero! Thank you

  • @georgebian5383
    @georgebian5383 Год назад

    so beautiful. Thank you!

  • @jaeen7665
    @jaeen7665 Год назад

    I'm a month and a half into my LeetCode grind. I can't believe a company would say: "Yeah, I need you to do LC 994, no aide, of the top of the dome." Really? smdh.

  • @krateskim4169
    @krateskim4169 2 года назад

    as always ,a beautiful solution

  • @kirillzlobin7135
    @kirillzlobin7135 6 месяцев назад

    Amazing video

  • @asdfasyakitori8514
    @asdfasyakitori8514 Год назад

    Great video

  • @YasirYSR
    @YasirYSR 3 года назад +1

    awesome. keep going.

  • @EranM
    @EranM 9 месяцев назад

    you can also think of getting a "node" which is a root, and point at all rotten oranges in the begining. And then simple BFS solve..

  • @ashwanikumar415
    @ashwanikumar415 5 месяцев назад

    @NeetCode why visited was not used , since if there are multiple rotten oranges this solution will run on those nodes again , right ?

    • @kaushik.aryan04
      @kaushik.aryan04 4 месяца назад +1

      no as we are marking oragnes with 2 whenver we add them to queue and if an orange is 2 we continue from the loop so vistited is not required

  • @mermaid6380
    @mermaid6380 3 года назад +1

    I remember seeing this problem at your channel before. At that time it was fresh set and rotten queue.Do I get incorrect memory?

    • @JJ-qv8co
      @JJ-qv8co 3 года назад

      commie stay in CN.

  • @DorKati
    @DorKati 2 года назад

    thanks man!

  • @nikhilchauhan5837
    @nikhilchauhan5837 3 года назад

    Great and easy to understand video. Suggestion: can you make video on sliding windows problem.. like find minimum number of operations to make that fixed size window satisfy some condition.

  • @jaimodha7523
    @jaimodha7523 2 года назад

    Amazingly explained :)

  • @yuenyiupang
    @yuenyiupang 2 года назад

    if we using popleft, is it not necessary to not have for i in range(len(q)), as it is already bfs, i mean i could just given a count together with x,y into q? is it? or that way is more clear?

    • @hamoodhabibi7026
      @hamoodhabibi7026 2 года назад +1

      it's neccessary for his code because he needs to go through the entire queue (thus simulating the spread of rotten simultaneously) to increment the timer count after all that. If we didn't have the forloop the timer would act like a dfs incrementing time one rotten path at a time

  • @dmytro.pyvovarenko
    @dmytro.pyvovarenko Год назад

    I doubt that you can do it with DFS anyhow. The DFS implies making a sequenced search in-depth till the very end. BFS makes queues to stack search tasks and computing minutes is much easier. Thus, BFS is the only option here.

  • @azharuddin6096
    @azharuddin6096 8 месяцев назад

    Just got done with this problem, I solved it even though I never came across multi-bfs pattern before. I was thinking about this problem in a little bit different way. However it was not working if there were more than 1 rotten oranges in the beginning. All I was missing was to put all the rotten oranges in the queue in the start and it worked after that. But this idea came to me from reading some comment. I don't know if should I mark this problem as solved by me?

  • @prathamhebbar5800
    @prathamhebbar5800 4 месяца назад

    Could you maybe explain why we are popping from the left?

  • @zwm495
    @zwm495 11 месяцев назад

    thank you

  • @danielsun716
    @danielsun716 2 года назад +1

    I tried to solve this problem with DFS, but while doing that, I find it more and more wrongly. Then I realize I have to do it by multi-source BFS.LOL

  • @kirillzlobin7135
    @kirillzlobin7135 Год назад

    Maaaaaaaaaaaaaaaaaaan, you are the legend

  • @arashkoushkebaghi1432
    @arashkoushkebaghi1432 10 месяцев назад +1

    So, what do we do if this video wasn't help? Should we just chuck our laptops at the wall?

  • @grovestreet9165
    @grovestreet9165 2 года назад

    c++ Solution:-
    class Solution {
    public:

    struct triplet{
    int i; // ith index
    int j; // jth index
    int time; // time

    };
    int orangesRotting(vector& grid) {

    queue q;

    const int x[4]={-1,0,1,0};
    const int y[4]={0,-1,0,1};

    int fresh_oranges=0;
    int oranges_rottened=0;

    for(int i=0;i

  • @soanonso
    @soanonso 2 года назад +1

    You forgot to use your ROWS and COLS vars when doing a bounds check.

  • @Nadi-x2v
    @Nadi-x2v 7 дней назад

    where is the bfs implementation in the code?

  • @yasirmalik198
    @yasirmalik198 11 месяцев назад

    popleft is not for popping more recently added oranges

  • @Dun1007
    @Dun1007 2 года назад

    what is time complexity?

  • @AmitKumar-cp1oz
    @AmitKumar-cp1oz 2 месяца назад +1

    I fucked up, i was asked this in an interview and couldn't answer!

    • @quirkyquester
      @quirkyquester Месяц назад

      better luck next time bro, i can't solve this either

  • @Redbugist
    @Redbugist 2 года назад

    why in line 24 is 'continue' but not 'return'?

    • @hamoodhabibi7026
      @hamoodhabibi7026 2 года назад

      because this is BFS not DFS we aren't using recursion so there is no call stack to return :p

  • @mathesharutchezhian6525
    @mathesharutchezhian6525 3 года назад +1

    Can you please do qn no.721 Merge Accounts ?

  • @tucker1351
    @tucker1351 2 года назад +1

    🐐

  • @lucasnbsb1
    @lucasnbsb1 2 года назад

    I'm down for pretty much any orange-based problem

  • @prathamhebbar5800
    @prathamhebbar5800 4 месяца назад

    Can you explain why we are popping left?

    • @TheBoon24
      @TheBoon24 3 месяца назад

      We pop left because queues follow a first in last out policy. In terms of BFS this is helpful because we are appending elements to the end of our queue which is the same thing as adding elements to the RIGHT of queue.
      Since the most recent elements in our queue are on the right side, that means our least recent elements are on the left. In a queue we want to pop the least recently added elements

  • @DBagg-zz4ip
    @DBagg-zz4ip 4 месяца назад

    I made the same pop instead of popleft mistake. That cost too much time to figure out.

  • @kohsheent
    @kohsheent 3 месяца назад

    what about maintaining a visited array, dont we need that?

    • @shyam2310
      @shyam2310 Месяц назад

      He is using the grid[row][column]!=1 as a condition. As we are changing the visited nodes value to 2, this condition ensures that we don’t visit them again

  • @sergiofranklin8809
    @sergiofranklin8809 2 года назад

    I don't know why but, if you use: directions = [[0, 1],[1,0],[-1,0],[0,-1]] it will fail, but if you use: directions = [[0, 1],[0,-1],[1,0],[-1,0]] it will pass. Please can anyone explain why, both of them are doing the same thing

    • @nikhil_a01
      @nikhil_a01 2 года назад +1

      Both passed for me. Are you sure you don't have some other problem in the code?

  • @harishsn4866
    @harishsn4866 2 года назад

    I came up with this solution but didn't occur to me that I should add fresh > 0 condition and wasted a lot of time.

  • @impatientgaming9868
    @impatientgaming9868 15 дней назад

    nice

  • @andreytamelo1183
    @andreytamelo1183 2 года назад

    Fresh-first (vs demonstrated rotten-first) approach (C#):
    public class Solution {
    public int OrangesRotting(int[][] grid) {

    int rows = grid.Length;
    int columns = grid[0].Length;

    HashSet freshes = new();

    for (int row = 0; row < rows; row++)
    for (int column = 0; column < columns; column++)
    if (grid[row][column] == 1) freshes.Add((row, column));

    int generations = 0;

    do
    {
    List toSpoil = new();

    foreach (var fresh in freshes)
    {
    bool badAbove = fresh.row > 0 && grid[fresh.row - 1][fresh.column] == 2;
    bool badOnRight = fresh.column + 1 < columns && grid[fresh.row][fresh.column + 1] == 2;
    bool badBelow = fresh.row + 1 < rows && grid[fresh.row + 1][fresh.column] == 2;
    bool badOnLeft = fresh.column > 0 && grid[fresh.row][fresh.column - 1] == 2;

    if (badAbove || badOnRight || badBelow || badOnLeft) toSpoil.Add(fresh);
    }

    if (toSpoil.Count == 0) break;

    foreach (var spoiled in toSpoil)
    {
    freshes.Remove(spoiled);
    grid[spoiled.row][spoiled.column] = 2;
    }

    generations++;

    } while (true);

    return freshes.Count == 0 ? generations : -1;
    }
    }

    • @andreytamelo1183
      @andreytamelo1183 2 года назад

      leetcode/problems/rotting-oranges/discuss/2107622/C-straightforward-brute-force-O(n*m)-fresh-first-easy-to-understand

  • @BananaButcher
    @BananaButcher 5 месяцев назад

    Orange

  • @BananaButcher
    @BananaButcher 5 месяцев назад

    Oinge

  • @lakhbawa
    @lakhbawa 3 года назад

    why cannot you use simple python, :< i am PHP / Java / JavaScript programmer, i am having to learn advance python to understand it :(

    • @ammarqureshi2155
      @ammarqureshi2155 3 года назад +8

      what part of it is advanced python? his code is as simple as it gets, its basically pseudocode at this point

    • @abhicasm9237
      @abhicasm9237 3 года назад

      😆

    • @jaslinkaur645
      @jaslinkaur645 3 года назад +2

      I think he's referring to the data structure like queue and deque

    • @donaldcodes
      @donaldcodes 2 года назад

      I'm dumb when it comes to understanding algos and I get his solution. I recommend brushing up on BFS if you don't understand this solution, because graphs are based on traversal algorithms like BFS and DFS